// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: OWIcrc.c
* \li ߲		: IAR EWAAVR 3.20a
* \li xҰ		: avr@atmel.com
*
* \li x޲	: SAVR
*
* \li pLq		: AVR318 - Dallas 1-Wire(R)呕u
*
* \li 			: 1-Wire(R)ő\IɎgpCRCZ@
*
*                         $Revision: 1.7 $
*                         $Date: Thursday, August 19, 2004 14:27:16 UTC $
****************************************************************************/

#include "OWIcrc.h"
#include "OWIdefs.h"

/*! \brief ްQCRC8lvZ
 *
 * ̊֐CRCɑ΂鏉lƂseedgpinDataCRC8܂DOW-CRCv
 * Z܂B
 *
 *  \param  inData	CRCvZް1޲
 *
 *  \param  seed	CRC̊Jnl
 *
 *  \return	lƂĂseedłinDataCRC8
 *
 *  \note	seed0ݒinDatacrc8()vZ܂B
 *
 *  \note	seedƂĂ̊֐̕ԂlpIɓnƂްCRC8
 *			lvZ܂B
 */
unsigned char OWI_ComputeCRC8(unsigned char inData, unsigned char seed)
{
  unsigned char bitsLeft;
  unsigned char temp;

  for (bitsLeft = 8; bitsLeft > 0; bitsLeft--)
  {
	temp = ((seed ^ inData) & 0x01);	// Ήޯ(LSB)_
	if (temp == 0)						// Ήޯ=0
	{
	  seed >>= 1;						// E1ޯĈړ
	}
	else								// Ήޯ=1
	{
	  seed ^= 0x18;						// X5,X4XOR
	  seed >>= 1;						// E1ޯĈړ
	  seed |= 0x80;						// X8XOR
	}
	inData >>= 1;						// E1ޯĈړ
  }
  return seed;							// ݂CRCƋɕA
}

/*! \brief ްQCRC16lvZ
 *
 * ̊֐CRCɑ΂鏉lƂseedgpinDataCRC16vZ܂B
 *
 *  \param  inData	CRCvZް1޲
 *
 *  \param  seed	CRC̊Jnl
 *
 *  \return	lƂĂseedłinDataCRC16
 *
 *  \note	seed0ݒinDatacrc16()vZ܂B
 *
 *  \note	seedƂĂ̊֐̕ԂlpIɓnƂްCRC16
 *			lvZ܂B
 */
unsigned int OWI_ComputeCRC16(unsigned char inData, unsigned int seed)
{
  unsigned char bitsLeft;
  unsigned char temp;

  for (bitsLeft = 8; bitsLeft > 0; bitsLeft--)
  {
	temp = ((seed ^ inData) & 0x01);	// Ήޯ(LSB)_
	if (temp == 0)						// Ήޯ=0
	{
	  seed >>= 1;						// E1ޯĈړ
	}
	else								// Ήޯ=1
	{
	  seed ^= 0x4002;					// X15,X2XOR
	  seed >>= 1;						// E1ޯĈړ
	  seed |= 0x8000;					// X16XOR
	}
	inData >>= 1;						// E1ޯĈړ
  }
  return seed;							// ݂CRCƋɕA
}

/*! \brief 64ޯROMʎqCRCvZƌ
 *
 * ̊֐64ޯĎʎq̐擪56ޯĂCRC8lvZ܂BROMɊi[
 * ĂCRClɑ΂ČvZl܂B
 *
 *  \param  romvalue	64ޯĎʎqێĂzւ߲
 *
 *  \retval OWI_CRC_OK		CRCv
 *  \retval OWI_CRC_ERROR	i[ĂCRCƌvZCRCԂɕsv
 */
unsigned char OWI_CheckRomCRC(unsigned char * romValue)
{
  unsigned char i;
  unsigned char crc8 = 0;

  for (i = 0; i < 7; i++)						// 56ޯ(7޲)CRCvZ
  {
	crc8 = OWI_ComputeCRC8(*romValue, crc8);	// Ή޲CRCvZ
	romValue++;									// ߲is
  }
  if (crc8 == (*romValue))						// MCRCƌvZCRCr
  {
	return OWI_CRC_OK;							// vňvlƋɕA
  }
  return OWI_CRC_ERROR;							// svŕsvlƋɕA
}
