// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: OWISWBitFunctions.c
* \li ߲		: IAR EWAAVR 3.20a
* \li xҰ		: avr@atmel.com
*
* \li x޲	: SAVR
*
* \li pLq		: AVR318 - Dallas 1-Wire(R)呕u
*
* \li 			: 1-Wire(R)Kł̊{IޯĒPʐM߰ݸ ĳ̂
*					  ̎
*
*                         $Revision: 1.7 $
*                         $Date: Thursday, August 19, 2004 14:27:18 UTC $
****************************************************************************/

#include "OWIPolled.h"

#ifdef OWI_SOFTWARE_DRIVER

#include <ioavr.h>
#include <inavr.h>

#include "OWIBitFunctions.h"

/*! \brief 1-Wire޽(ĳ̂ݔ)
 *
 * ̊֐1-Wire޽J邱ƂɂĂAݐM()I
 * ܂ő҂܂B
 *
 *  \param  pins	޽ޯĎՕl
 */
void OWI_Init(unsigned char pins)
{
  OWI_RELEASE_BUS(pins);					// 1-Wire޽J(Hi-Z)
  __delay_cycles(OWI_DELAY_H_STD_MODE);		// ݐMԕҋ@
  // ㏸[͏]uɂؾĐM̏IƂĉ߂꓾܂BۂؾĐM
  // ߂̂ۏ؂邽߂ɁAKvؾĐM񕜎(H)Ax
  // ܂B
}

/*! \brief ޽ւ'1'(ĳ̂ݔ)
 *
 * 1-Wire޽'1'ޯđMpg`𐶐܂B
 *
 *  \param  pins	޽ޯĎՕl
 */
void OWI_WriteBit1(unsigned char pins)
{
  unsigned char intState;

  intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
  __disable_interrupt();					// S̊荞݋֎~
  OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
  __delay_cycles(OWI_DELAY_A_STD_MODE);		// 1LԎԑҋ@
  OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
  __delay_cycles(OWI_DELAY_B_STD_MODE);		// 1ݎcԑҋ@
  __restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
}

/*! \brief ޽ւ'0'(ĳ̂ݔ)
 *
 * 1-Wire޽'0'ޯđMpg`𐶐܂B
 *
 *  \param  pins	޽ޯĎՕl
 */
void OWI_WriteBit0(unsigned char pins)
{
  unsigned char intState;

  intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
  __disable_interrupt();					// S̊荞݋֎~
  OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
  __delay_cycles(OWI_DELAY_C_STD_MODE);		// 0LԎԑҋ@
  OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
  __delay_cycles(OWI_DELAY_D_STD_MODE);		// 0ݎcԑҋ@
  __restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
}

/*! \brief ޽ޯēǂݍ(ĳ̂ݔ)
 *
 * 1-Wire޽ޯĎMpg`𐶐܂B
 *
 *  \param  pins	ǂݍ޽ޯĎՕl
 *
 *  \return			'1'ǂ܂ꂽ޽ޯĎՕl
 */
unsigned char OWI_ReadBit(unsigned char pins)
{
  unsigned char intState;
  unsigned char bitsRead;

  intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
  __disable_interrupt();					// S̊荞݋֎~
  OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
  __delay_cycles(OWI_DELAY_A_STD_MODE);		// ǂݍLԎԑҋ@
  OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
  __delay_cycles(OWI_DELAY_E_STD_MODE);		// ̎xҋ@
  bitsRead = OWI_PIN & pins;				// Ή޽Ԓl擾
  __delay_cycles(OWI_DELAY_F_STD_MODE);		// ǂݍݎcԑҋ@
  __restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
  return bitsRead;							// Ή޽擾ޯĒlƋɕA
}

/*! \brief ؾĐMoƑݐM(ĳ̂ݔ)
 *
 * 1-Wire޽ؾđMpg`𐶐AݐM𒮎悵܂B
 *
 *  \param  pins	ؾĐM𑗏o޽ޯĎՕl
 *
 *  \return			ݐMoꂽ޽ޯĎՕl
 */
unsigned char OWI_DetectPresence(unsigned char pins)
{
  unsigned char intState;
  unsigned char presenceDetected;

  intState = __save_interrupt();			// ݂̑S̊荞݋ޯĂꎞۑ
  __disable_interrupt();					// S̊荞݋֎~
  OWI_PULL_BUS_LOW(pins);					// Ή޽Lowݒ
  __delay_cycles(OWI_DELAY_H_STD_MODE);		// ؾĐMLԎԑҋ@
  OWI_RELEASE_BUS(pins);					// Ή޽J(Hi-Z)
  __delay_cycles(OWI_DELAY_I_STD_MODE);		// ̎xҋ@
  presenceDetected = ((~OWI_PIN) & pins);	// Ή޽ݐMl擾
  __delay_cycles(OWI_DELAY_J_STD_MODE);		// ݐMcԑҋ@
  __restore_interrupt(intState);			// {֐Jn̑S̊荞݋/֎~Ԃ
  return presenceDetected;					// Ή޽ݐMlƋɕA
}

#endif
