// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: main.c
* \li ߲		: IAR EWAAVR 3.20a
* \li xҰ		: avr@atmel.com
*
* \li x޲	: SAVR
*
* \li pLq		: AVR318 - Dallas 1-Wire(R)呕u
*
* \li 			: 1-Wire(R)̪呕ugp@̗
*
*                         $Revision: 1.7 $
*                         $Date: Thursday, August 19, 2004 14:27:18 UTC $
****************************************************************************/

#include <ioavr.h>
#include <inavr.h>

#include "OWIPolled.h"
#include "OWIHighLevelFunctions.h"
#include "OWIBitFunctions.h"
#include "..\common_files\OWIcrc.h"

#include <string.h>								// memcpypɎgp

// ޗႾŎgp`
#define DS1820_FAMILY_ID				0x10	// DS1820nʎq
#define DS1820_START_CONVERSION			0x44	// DS1820ϊJnߕ
#define DS1820_READ_SCRATCHPAD			0xBE	// DS1820GLǂݍݖߕ
#define DS1820_ERROR					-1000   // DS1820߂蕄(͈͊Ox)

#define DS2890_FAMILY_ID				0x2C	// DS2890nʎq
#define DS2890_WRITE_CONTROL_REGISTER	0x55	// DS2890ڼ޽ݖߕ
#define DS2890_RELEASE_CODE				0x96	// DS2890Jߕ
#define DS2890_WRITE_POSITION			0x0F	// DS2890ʒuݖߕ

#define SEARCH_SUCCESSFUL				0x00	// 
#define SEARCH_CRC_ERROR				0x01	// CRC蕄

#define FALSE       0
#define TRUE        1

#define MAX_DEVICES 8							//!< ɑ΂ő呕u

#define BUSES   (OWI_PIN_0 | OWI_PIN_1)			//!< ɑ΂޽(ڑ)

/*! \brief ]uɂĂ̏ێ̂Ɏgpް^
 *
 * OWI_deviceް^͊euǂ޽ɐڑĂ邩Ƃ64ޯĎʎqɂ
 * Ă̏ێ܂B
 */
typedef struct
{
    unsigned char bus;		//!< uڑĂ޽ޯĎՕl
    unsigned char id[8];	//!< 64ޯĎʎq
} OWI_device;

// Ŏgp֐̌^錾
unsigned char SearchBuses(OWI_device * devices, unsigned char len, unsigned char buses);
OWI_device * FindFamily(unsigned char familyID, OWI_device * devices, unsigned char size);
signed int DS1820_ReadTemperature(unsigned char bus, unsigned char * id);
void DS2890_SetWiperPosition(unsigned char position, unsigned char bus, unsigned char * id);

/*! \brief ߰ݸ ײޗp̉p
 *
 * ĳ݂̂߰ݸUARTײޗp̉p
 * ̉pBUSESɂĒ`ꂽ޽(MAX_DEVICESɂ)SĂ̑
 * uT܂B޽DS1820DS2890̂ǂ炩̑uTƂ݁A
 * xǂݍ(DS1820)܂͐ʒuݒ(DS2890)łƒʐM܂B
 * ̗͂܂œKȕ@ŏĂ܂BP߰ݸ1-Wire(R)ײނǂ
 * gp꓾邩ƂӐ}Ăɂ܂B
 */
void main(void)
{
  static OWI_device devices[MAX_DEVICES];
  OWI_device * ds1820;
  OWI_device * ds2890;
  signed int temperature = 0;
  unsigned char wiperPos = 0;

  DDRB = 0xFF;		// S߰Bo͐ݒ(STK500JLEDŒl\̂Ɏgp邱Ƃł܂B)
  OWI_Init(BUSES);	// 1-Wireײޏ

  while(SearchBuses(devices, MAX_DEVICES, BUSES) != SEARCH_SUCCESSFUL)
  {
  // SĂ̎ʎqCRCȂœǂ܂܂޽s
  }
  ds1820 = FindFamily(DS1820_FAMILY_ID, devices, MAX_DEVICES);	// DS1820L擾
  ds2890 = FindFamily(DS2890_FAMILY_ID, devices, MAX_DEVICES);	// DS2890L擾

  for (;;)							// JԂ(]uŗLpȉsĂB)
  {
	if (ds1820 != NULL)				// DS1820LŁA(:DS1820Vdd݂ڑĂȂ΂Ȃ܂B)
	{
	  temperature = DS1820_ReadTemperature((*ds1820).bus, (*ds1820).id);	// DS1820x擾
	}
	if (ds2890 != NULL)				// DS2890LŁA
	{
	  DS2890_SetWiperPosition(wiperPos++, (*ds2890).bus, (*ds2890).id);		// DS2890ʒuݒ(ʒuis)
	}
	PORTB = ~(temperature >> 1);	// LSBjx߰Bɏo
  }
}

/*! \brief 1-Wires
 *
 * ̊֐޽̑Su𔭌̂OWI_SearchRom֐ǂgp꓾邩
 * ܂B64ޯĎʎqCRC܂B
 *
 *  \param  devices	OWI_device^̔zւ߲Bꂽu̔z̐擪
 *					zu܂B
 *
 *  \param  len		uz(vf̍ő吔)
 *
 *  \param  buses	s޽̎Օl
 *
 *  \retval SEARCH_SUCCESSFUL	
 *  \retval SEARCH_CRC_ERROR	CRC蔭B(AM̎Ĝ)
 */
unsigned char SearchBuses(OWI_device * devices, unsigned char len, unsigned char buses)
{
  unsigned char i, j;
  unsigned char presence;
  unsigned char * newID;
  unsigned char * currentID;
  unsigned char currentBus;
  unsigned char lastDeviation;
  unsigned char numDevices;

  for (i = 0; i < len; i++)					// uz񏉊
  {
	devices[i].bus = 0x00;					// Ή޽Օl(0=Ȃ)
	for (j = 0; j < 8; j++)					// 1޽ʎq
	{
	  devices[i].id[j] = 0x00;				// Ήʎq
	}
  }

  presence = OWI_DetectPresence(BUSES);		// ]u޽̌
  numDevices = 0;							// ]uv평
  newID = devices[0].id;					// ʎql擾(S0l)
  for (currentBus = 0x01; currentBus; currentBus <<= 1)		// S޽SʎqzɎ擾
  {											// ޽Pʌ
	lastDeviation = 0;						// ʎqޯĈʒu
	currentID = newID;
	if (currentBus & presence)				// Ή޽p\(L]uL)ŁA
	{
	  do									// Ή޽S]uʎqzɎ擾
	  {
		memcpy(newID, currentID, 8);		// O̗LʎqnewIDɕ
		OWI_DetectPresence(currentBus);		// Ή޽uؾ
		lastDeviation = OWI_SearchRom(newID, lastDeviation, currentBus);	// ]uʎq(zʎqݒ)
		currentID = newID;					// ݂̎ʎq߲ꎞۑ
		devices[numDevices].bus = currentBus;	// uz̑Ήʒu޽Օlݒ
		numDevices++;						// ]uvis
		newID=devices[numDevices].id;		// zʒu߲擾
	  }  while(lastDeviation != OWI_ROM_SEARCH_FINISHED);	// Ή޽܂Ōp
	}
  }
  for (i = 0; i < numDevices; i++)			// SʎqCRC
  {
	if(OWI_CheckRomCRC(devices[i].id) != OWI_CRC_OK)	// MCRCƌvZCRCsvŁA
	{
	  return SEARCH_CRC_ERROR;							// CRCُ필ƋɕA
	}
  }
  return SEARCH_SUCCESSFUL;								// ƋɕA
}

/*! \brief nʎqɊn̍ŏ̑u
 *
 * ̊֐͎wnɈv鑕uz̑uւ߲Ԃ܂B
 *
 *  \param  familyID	8ޯĂ̌nʎq
 *
 *  \param  devices		suz
 *
 *  \param  size		uz̎ʎq
 *
 *  \return			n̑uւ߲
 *  \retval NULL	n̑uȂꍇ
 */
OWI_device * FindFamily(unsigned char familyID, OWI_device * devices, unsigned char size)
{
  unsigned char i = 0;

  while (i < size)						// zS
  {
	if ((*devices).id[0] == familyID)	// ΉʎqnʎqƈvŁA
	{
	  return devices;					// vʎq߲ƋɕA
	}
	devices++;							// uzʎqʒuis
	i++;								// vis
  }
  return NULL;							// oƋɕA
}

/*! \brief DS1820xm킩牷xǂݍ
 *
 * ̊֐͕ϊJnDDS1820xm킩̉xǂݖ߂܂B
 *
 *  \param		DS1820zuĂ޽޽Օl
 *
 *  \param  id	DS182064ޯĎʎq
 *
 *  \return		DS1820ǂ񂾕t16ޯĉxl
 */
signed int DS1820_ReadTemperature(unsigned char bus, unsigned char * id)
{
  signed int temperature;

  if (!OWI_DetectPresence(bus))					// DS18201-Wire]uؾĂŕs݂ȂA
  {
	return DS1820_ERROR;						// DS1820ُ필ƋɕA
  }
  OWI_MatchRom(id, bus);						// DS1820]uw
  OWI_SendByte(DS1820_START_CONVERSION, bus);	// ϊJnߑM
  while (!OWI_ReadBit(bus))						// ϊҋ@(ϊ܂DS1820Low𑗏o)
  {
  }
  if(!OWI_DetectPresence(bus))					// DS18201-Wire]uؾĂŕs݂ȂA
  {
	return -1000;								// DS1820͈͊OxƋɕA
  }
  OWI_MatchRom(id, bus);						// DS1820]uw
  OWI_SendByte(DS1820_READ_SCRATCHPAD, bus);	// GLǂݍݖߑM
  temperature = OWI_ReceiveByte(bus);			// x޲Ď擾
  temperature |= (OWI_ReceiveByte(bus) << 8);	// x޲Ď擾,16ޯč
  return temperature;							// xlƋɕA
}

/*! \brief DS2890̐ʒuݒ
 *
 * ̊֐߂邱ƂɂDS2890܂BĐ
 * uύX܂B
 *
 *  \param  position	Vʒu
 *
 *  \param  bus			DS2890ڑꂽ޽޽Օl
 *
 *  \param  id			DS289064ޯĎʎq
 */
void DS2890_SetWiperPosition(unsigned char position, unsigned char bus, unsigned char * id)
{
  if(!OWI_DetectPresence(bus))					// DS28901-Wire]uؾĂŕs݂ȂA
  {
	return;
  }
  OWI_MatchRom(id, bus);						// DS2890]uw
  OWI_SendByte(DS2890_WRITE_CONTROL_REGISTER, bus);		// ڼ޽ݖߑM
  OWI_SendByte(0x4C, bus);						// ߋlM
  if (OWI_ReceiveByte(bus) != 0x4C)				// MlƍُŁA
  {
	return;
  }
  OWI_SendByte(DS2890_RELEASE_CODE, bus);		// JߑM(ڼ޽XV)
  if (OWI_ReceiveByte(bus) == 0xFF)				// 쎸sŁA(̏ꍇ0Ԃ܂B)
  {
	return;
  }
  if (!OWI_DetectPresence(bus))					// DS28901-Wire]uؾĂŕs݂ȂA
  {
	return;
  }
  OWI_MatchRom(id, bus);						// DS2890]uw
  OWI_SendByte(DS2890_WRITE_POSITION, bus);		// ʒuݖߑM
  OWI_SendByte(position, bus);					// ʒulM
  if (OWI_ReceiveByte(bus) != position)			// MlƍُŁA
  {
	return;
  }
  OWI_SendByte(DS2890_RELEASE_CODE, bus);		// JߑM(ʒuXV)
  if (OWI_ReceiveByte(bus) == 0xFF)				// 쎸sŁA(̏ꍇ0Ԃ܂B)
  {
	return;
  }
}
