// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: OWIUARTFunctions.c
* \li ߲		: IAR EWAAVR 3.20a
* \li xҰ		: avr@atmel.com
*
* \li x޲	: SAVR
*
* \li pLq		: AVR318 - Dallas 1-Wire(R)呕u
*
* \li 			: 1-Wire(R)Kł̊{IޯĒPʐM߰ݸUART
*
*                         $Revision: 1.7 $
*                         $Date: Thursday, August 19, 2004 14:27:18 UTC $
****************************************************************************/

#include "OWIPolled.h"

#ifdef OWI_UART_DRIVER

#include <ioavr.h>

#include "OWIBitFunctions.h"

/*! \brief 1-Wire޽(߰ݸUARTײޔ)
 *
 * ̊֐UART`Ԑݒ肷邱Ƃɂ1-Wire޽܂B
 */
void OWI_Init()
{
  OWI_UART_STATCTRL_REG_A = (OWI_UART_2X << OWI_U2X);								// W/{̑I
  OWI_UART_STATCTRL_REG_B = (1 << OWI_TXEN) | (1 << OWI_RXEN);						// M,M
  // (ȉUCSRCݒ޲̏lƓȂ̂ō폜邱Ƃł܂B)
#ifdef URSEL	// pzuŁA
  OWI_UART_STATCTRL_REG_C = (1 << OWI_URSEL) | (1 << OWI_UCSZ1) | (1 << OWI_UCSZ0);	// UCSRCڼ޽I,8ޯ ް,èȂ,1~ޯĎw
#else			// ʔzuŁA
  OWI_UART_STATCTRL_REG_C = (1 << OWI_UCSZ1) | (1 << OWI_UCSZ0);					// 8ޯ ް,èȂ,1~ޯĎw
#endif
  OWI_UART_BAUD_RATE_REG_L = OWI_UBRR_115200;										// ްڰĂ115200bpsݒ
}

/*! \brief 1-Wire޽1ޯĂ݂̏Ɠǂݍ(߰ݸUARTײޔ)
 *
 * ޽1ޯĂA޽ǂ񂾒lԂ܂B
 *
 *  \param  outValue	޽ɑMޯĒl
 *
 *  \return				޽UARTɂĎMl
 */
unsigned char OWI_TouchBit(unsigned char outValue)
{
  OWI_UART_DATA_REGISTER = outValue;					// UDRɎwlݒ
  while(!(OWI_UART_STATCTRL_REG_A & (1 << OWI_RXC)))	// UARTM׸ސݒ܂őҋ@
  {
  }
  OWI_UART_BAUD_RATE_REG_L = OWI_UBRR_115200;			// ްڰĂ115200bpsɍĐݒ(ؾ/ݗp)
  return OWI_UART_DATA_REGISTER;						// UDRMlƋɕA
}

/*! \brief ޽ւ'1'(߰ݸUARTײޔ)
 *
 * 1-Wire޽'1'ޯđMpg`𐶐܂B
 */
void OWI_WriteBit1()
{
  OWI_TouchBit(OWI_UART_WRITE1);						// 1ݐM
}

/*! \brief ޽ւ'0'(߰ݸUARTײޔ)
 *
 * 1-Wire޽'0'ޯđMpg`𐶐܂B
 */
void OWI_WriteBit0()
{
  OWI_TouchBit(OWI_UART_WRITE0);						// 0ݐM
}

/*! \brief ޽ޯēǂݍ(߰ݸUARTײޔ)
 *
 * 1-Wire޽ޯĎMpg`𐶐܂B
 *
 *  \return	޽ǂ܂ꂽl(0܂1)
 */
unsigned char OWI_ReadBit()
{
  return (OWI_TouchBit(OWI_UART_READ_BIT) == OWI_UART_READ_BIT);	// ǂݍݒl(1/0)ƋɕA
  // ǂݍݐMUARTMlUARTMlƓ΁A]u޽
  // 삵Ȃ̂ŁAǂݍݒl1BȂΏ]u޽LowɈ
  // ƂɂȂ̂ŁAǂݍݒl0B
}

/*! \brief ؾĐMoƑݐM(߰ݸUARTײޔ)
 *
 * 1-Wire޽ؾđMpg`𐶐AݐM𒮎悵܂B
 *
 *  \return	ݐM̗L(1=L,0=Ȃ)
 */
unsigned char OWI_DetectPresence()
{
  OWI_UART_STATCTRL_REG_B &= ~(1 << OWI_RXEN);				// Mꎞ֎~(M׸މ̂)
  OWI_UART_STATCTRL_REG_B |= (1 << OWI_RXEN);				// Mċ
  OWI_UART_BAUD_RATE_REG_L = OWI_UBRR_9600;					// ްڰĂ9600bpsݒ
  return (OWI_TouchBit(OWI_UART_RESET) != OWI_UART_RESET);	// ݐMLlƋɕA
  // ؾĐMo/ݐMMɑ΂UARTMlUARTMlƓ΁A]
  // u޽𑀍삵Ȃ̂ŁAݐMȂ(0)BȂΏ]u޽Low
  // ɈƂɂȂ̂ŁAݐM(1)B
}


#endif
